
// 	***********************************************************************
//	File : SPI_MASTER.c
//	***********************************************************************

#include 	<p30F4011.h>
#include 	"C30EVM_LCD.h"			// NLCD禡쫬ŧiɮקtJ 
#include	<timer.h>				// NTimer禡쫬ŧiɮקtJ
#include	<adc10.h>				// Nadc10禡쫬ŧiɮקtJ
#include	"ADCSubs.h"
#include	"SPISubs.h"

#define		FCY 	7372800 * 2		// ]ϥWvN~ 7.3728 MHz * 8 Ҧ , C@Og 4  clock
									// ҥH FCY =  (7.3728 * 8 / 4 ) MHz = 7372800* 2

   	_FOSC(CSW_FSCM_OFF & XT_PLL8);   //	XT with 8xPLL oscillator, Failsafe clock off
   	_FWDT(WDT_OFF);                  //	Watchdog timer disabled
  	_FBORPOR(PBOR_OFF & MCLR_EN);    //	Brown-out reset disabled, MCLR reset enabled
   	_FGS(CODE_PROT_OFF);             //	Code protect disabled

const char	My_String1[]="VR1:    VR2:    " ;	// ŧir Program Memory (] const ŧi)
	  char	My_String2[]="EE1:    EE2:    " ;	// ŧir Data Memory

unsigned int miliSec ;

void	Init_ADC(void) ;
void	Show_ADC(void) ;
void	SPI_Delay(void) ;

// union ŧiN8줸ܼByteAccessPSystemFlagcܼƨϥάۦPOA
// HQP榡줸BݨD
union 	{
			unsigned char ByteAccess ;
			struct 	{
						unsigned Bit0: 1 ;
						unsigned Bit1: 1 ;
						unsigned Bit2: 1 ;
						unsigned unused : 5 ;
					} ;
		} SystemFlag ;

//wqOneSecondXеPSystemFlag.Bit0줸ܼơAGNϥΤ@Ӧ줸OЪŶ
#define	OneSecond	SystemFlag.Bit0 

volatile	unsigned char	SPI_ReadBuffer ;
volatile 	unsigned char	SPI_State = 0 ;	
volatile	unsigned char	SPI_Buffer[64] ;
volatile	unsigned int	SPI_BufferIndex ;	

void _ISR _T1Interrupt(void)		//Timer1_Ƶ{
{

	miliSec += 1 ;

	if (miliSec == 1000)		//C1000NOneSecondXг]w1
		{
			OneSecond = 1 ;
			miliSec  = 0 ;
		} 
	IFS0bits.T1IF = 0 ;		//M_X

}


void	_ISR	_SPI1Interrupt(void)			//	SPI  Interrupt service routine !!
{
		IFS0bits.SPI1IF = 0 ;
		
		SPI_ReadBuffer = SPI1BUF ;

		//
		//	SPI_State ҥNA :
		//	0 : 	|즳 COMMAND
		//	0x10:	wg  WRITE COMMAND ,  Address  High Byte
		//	0x11:	wg Address  High Byte , ݱ Address  Low Byte
		//	0x12:	wg Address  Low Byte , ݱngJ Data
		//			>>	 SPI_State == 0x12 , BS@ Byte Q ,  Byte ngJ Data
		//			>>	dsPIC ݱN Address Low  , N SPI1BUF ƼgJ SPI_Buffer[] 
		//			>>	OoN SPI_State ks 
		//
		//	0x20:	wg  READ COMMAND ,  Address  High Byte
		//	0x21:	wg Address  High Byte , ݱ Address  Low Byte
		//			>>	 SPI_State == 0x21 , BS@ Byte Q ,  Byte  Address Low
		//			>>	dsPIC ݱN Address Low  , Xb SPI_Buffer[] ƨügJ SPI1BUF
		//				pƴN|Q~e
		//	0xff:	ܥe COMMAND wg , N 0x00 gJ SPI1BUF Yi 
		//			>> 	OonN SPI_State ks
		//
		switch (SPI_State)
		{

			case	0 : 										//	@ COMMAND Stage ..................
					
					if ( SPI_ReadBuffer == SPI_RD_STATUS)	
							{ 
								SPI1BUF = 0x00 ;				//	Ȥz| COMMAND
								SPI_State = 0xff ;				// 
							}
					else if ( SPI_ReadBuffer == SPI_WR_STATUS )	
							{
								SPI1BUF = 0x00 ;				//	Ȥz| COMMAND
								SPI_State = 0xff ;
							}
					else if ( SPI_ReadBuffer == SPI_EE_WREN )
							{

								SPI1BUF = 0x00 ;				//	Ȥz| COMMAND ( Single Byte )
								SPI_State = 0 ;
							}
					else if ( SPI_ReadBuffer == SPI_EE_WRDIS )
							{

								SPI1BUF = 0x00 ;				//	Ȥz| COMMAND ( Single Byte )
								SPI_State = 0 ;
							}
					else if ( SPI_ReadBuffer == SPI_EE_WRITE )
							{

								SPI1BUF = 0x00 ;
								SPI_State = 0x10 ;
							}
					else if ( SPI_ReadBuffer == SPI_EE_READ )
							{

								SPI1BUF = 0x00 ;
								SPI_State = 0x20 ;
							}
					break ;
			case	0x10 :							//	Address High for Write Command 
						SPI1BUF = 0x00 ;
						SPI_State ++ ;
						break ;
			case	0x11 :
						SPI_BufferIndex = SPI1BUF ;
						SPI_State ++ ;
						break ;
			case	0x12 :
						SPI_Buffer[SPI_BufferIndex] = SPI1BUF ;
						SPI_BufferIndex ++ ;
						SPI_State = 0x00 ;
						break ;
			case	0x20 :							//	Address High for Write Command 
						SPI1BUF = 0x00 ;
						SPI_State ++ ;
						break ;
			case	0x21 :
						SPI_BufferIndex = SPI1BUF ;
						SPI1BUF = SPI_Buffer[SPI_BufferIndex];
						SPI_BufferIndex ++ ;
						SPI_State = 0xff ;
						break ;					
			default :
						SPI1BUF = 0x00 ;
						SPI_State = 0 ;
						break ;
		}

}

	unsigned int 	ADC_Value;

int	main( void )
{


	Init_ADC( ) ;										// NADCilƳ]w
	Init_SPI( ) ;

	OpenLCD( ) ;										// ϥ OpenLCD( ) LCD Ҳէ@lƳ]w
														// 4 bits Data mode
														// 5 * 7 Character 

	setcurLCD(0,0) ;									// ϥ setcurLCD( ) ]wЩ (0,0)
	putrsLCD( My_String1 ) ;							// Nsb Program Memory rϥ
														// putrsLCD( ) LX LCD
			
	setcurLCD(0,1) ;									// ϥ setcurLCD( ) ]wЩ (0,1)
	putrsLCD( My_String2 ) ;							// Nsb Data Memory rϥ
														// putsLCD( ) LX LCD

	ConfigIntTimer1( T1_INT_PRIOR_7 & T1_INT_ON ) ;		// Timer1 _uų] 7 (̰)
														// Timer1 _ ON 

	OpenTimer1( T1_ON & T1_IDLE_STOP & T1_GATE_OFF & 	// Timer1  Period ]C 1ms 
				T1_PS_1_1 & T1_SYNC_EXT_OFF & T1_SOURCE_INT ,
				(FCY/ 1000) ) ;

	OneSecond = 0 ;

	while(1) 
	{	
		if ( OneSecond ) 								// ߰ Timer1  Period ɶO_w
														// iHγnˬdO_ǽT 1 ms
		{
			OneSecond = 0 ;	
			Nop() ;						 
			
			ADC_Value = Get_VR1( ) ;								
			setcurLCD(4,0) ;							// Set LCD cursor		
			put_Num_LCD( ADC_Value >> 2 ) ;				// NഫGHQiƦrܦܲGܾ

			ADC_Value = Get_VR2( ) ;								
			setcurLCD(12,0) ;							// Set LCD cursor		
			put_Num_LCD( ADC_Value >> 2 ) ;				// NഫGHQiƦrܦܲGܾ	

			setcurLCD(4,1) ;							// Set LCD cursor		
			put_Num_LCD( SPI_Buffer[0x10] ) ;				
			setcurLCD(12,1) ;							// Set LCD cursor		
			put_Num_LCD( SPI_Buffer[0x20] ) ;				

		}
	}		
}
